Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 13437)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRPPXCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 13437)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRInsertionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
@@ -43,5 +43,5 @@
       int cutIndex = random.Next(individual.PermutationWithRepetition.Length);
       int insertIndex = random.Next(individual.PermutationWithRepetition.Length);
-      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone())).ToList();
       int aux = perm[cutIndex];
       if (cutIndex > insertIndex) {
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
   [StorableClass]
@@ -33,8 +33,5 @@
     protected PWRManipulator(bool deserializing) : base(deserializing) { }
     protected PWRManipulator(PWRManipulator original, Cloner cloner) : base(original, cloner) { }
-    public PWRManipulator()
-      : base() {
-      ScheduleParameter.ActualName = "PermutationWithRepetition";
-    }
+    public PWRManipulator() : base() { }
 
     protected abstract void Manipulate(IRandom random, PWREncoding individual);
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PermutationWithRepetitionEncoding", "Represents a encoding for a standard JobShop Scheduling Problem.")]
   [StorableClass]
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 13437)
@@ -22,10 +22,9 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PermutationWithRepetitionRandomCreator", "Creates PWR-individuals at random.")]
   [StorableClass]
@@ -34,10 +33,4 @@
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
 
@@ -48,8 +41,4 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
-
-      ScheduleParameter.ActualName = "PermutationWithRepetition";
     }
 
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 13437)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 13437)
@@ -0,0 +1,68 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class PermutationWithRepetitionEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private PermutationWithRepetitionEncoding(bool deserializing) : base(deserializing) { }
+    private PermutationWithRepetitionEncoding(PermutationWithRepetitionEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationWithRepetitionEncoding(this, cloner);
+    }
+
+    public PermutationWithRepetitionEncoding()
+      : base() {
+      SolutionCreator = new PWRRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static PermutationWithRepetitionEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IPWROperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+  }
+}
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 13437)
@@ -24,5 +24,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVCrossover", "An operator which crosses two PRV representations.")]
   [StorableClass]
@@ -32,9 +32,5 @@
     protected PRVCrossover(bool deserializing) : base(deserializing) { }
     protected PRVCrossover(PRVCrossover original, Cloner cloner) : base(original, cloner) { }
-    public PRVCrossover()
-      : base() {
-      ParentsParameter.ActualName = "PriorityRulesVector";
-      ChildParameter.ActualName = "PriorityRulesVector";
-    }
+    public PRVCrossover() : base() { }
 
     public abstract PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVDiscreteCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVSinglePointCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVManipulator", "An operator which manipulates a PRV representation.")]
   [StorableClass]
@@ -32,8 +32,5 @@
     protected PRVManipulator(bool deserializing) : base(deserializing) { }
     protected PRVManipulator(PRVManipulator original, Cloner cloner) : base(original, cloner) { }
-    public PRVManipulator()
-      : base() {
-      ScheduleParameter.ActualName = "PriorityRulesVector";
-    }
+    public PRVManipulator() : base() { }
 
     protected abstract void Manipulate(IRandom random, PRVEncoding individual);
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVUniformOnePositionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
@@ -41,5 +41,5 @@
 
     public static void Apply(IRandom random, PRVEncoding individual) {
-      UniformOnePositionManipulator.Apply(random, individual.PriorityRulesVector, new IntMatrix(new int[,] { { 0, individual.NrOfRules.Value } }));
+      UniformOnePositionManipulator.Apply(random, individual.PriorityRulesVector, new IntMatrix(new int[,] { { 0, individual.NrOfRules } }));
     }
 
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs	(revision 13437)
@@ -23,9 +23,8 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PriorityRulesVectorEncoding", "Represents an encoding for a Scheduling Problem.")]
   [StorableClass]
@@ -35,10 +34,5 @@
 
     [Storable]
-    private IntValue nrOfRules;
-    public IntValue NrOfRules {
-      get {
-        return nrOfRules;
-      }
-    }
+    public int NrOfRules { get; private set; }
 
     [StorableConstructor]
@@ -46,20 +40,20 @@
     protected PRVEncoding(PRVEncoding original, Cloner cloner)
       : base(original, cloner) {
-      this.nrOfRules = cloner.Clone(original.NrOfRules);
+      this.NrOfRules = original.NrOfRules;
       this.PriorityRulesVector = cloner.Clone(original.PriorityRulesVector);
     }
     public PRVEncoding(int nrOfRules)
       : base() {
-      this.nrOfRules = new IntValue(nrOfRules);
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = new IntegerVector();
     }
-    public PRVEncoding(IntegerVector iv, IntValue nrOfRules)
+    public PRVEncoding(IntegerVector iv, int nrOfRules)
       : base() {
-      this.nrOfRules = (IntValue)nrOfRules.Clone();
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = (IntegerVector)iv.Clone();
     }
-    public PRVEncoding(int length, IRandom random, int min, int max, IntValue nrOfRules)
+    public PRVEncoding(int length, IRandom random, int min, int max, int nrOfRules)
       : base() {
-      this.nrOfRules = (IntValue)nrOfRules.Clone();
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = new IntegerVector(length, random, min, max);
     }
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 13437)
@@ -22,10 +22,9 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PriorityRulesRandomCreator", "Creator class used to create PRV encoding objects for scheduling problems.")]
   [StorableClass]
@@ -33,14 +32,8 @@
 
     [Storable]
-    public IntValue NrOfRules { get; set; }
+    public int NrOfRules { get; set; }
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
 
@@ -49,21 +42,18 @@
     protected PRVRandomCreator(PRVRandomCreator original, Cloner cloner)
       : base(original, cloner) {
-      this.NrOfRules = cloner.Clone(original.NrOfRules);
+      this.NrOfRules = original.NrOfRules;
     }
-    public PRVRandomCreator()
-      : base() {
-      NrOfRules = new IntValue(10);
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
-      ScheduleParameter.ActualName = "PriorityRulesVector";
-    }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PRVRandomCreator(this, cloner);
     }
 
-    public static PRVEncoding Apply(int jobs, int resources, IRandom random, IntValue nrOfRules) {
-      return new PRVEncoding(jobs * resources, random, 0, nrOfRules.Value, nrOfRules);
+    public PRVRandomCreator()
+      : base() {
+      NrOfRules = 10;
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+    }
+
+    public static PRVEncoding Apply(int jobs, int resources, IRandom random, int nrOfRules) {
+      return new PRVEncoding(jobs * resources, random, 0, nrOfRules, nrOfRules);
     }
 
@@ -71,6 +61,4 @@
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue, NrOfRules);
     }
-
-
   }
 }
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 13437)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 13437)
@@ -0,0 +1,68 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class PriorityRulesVectorEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private PriorityRulesVectorEncoding(bool deserializing) : base(deserializing) { }
+    private PriorityRulesVectorEncoding(PriorityRulesVectorEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PriorityRulesVectorEncoding(this, cloner);
+    }
+
+    public PriorityRulesVectorEncoding()
+      : base() {
+      SolutionCreator = new PRVRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static PriorityRulesVectorEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IPRVOperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+  }
+}
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 13436)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 13437)
@@ -22,4 +22,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Operators;
 using HeuristicLab.Parameters;
@@ -34,4 +35,10 @@
       get { return (ILookupParameter<ISchedule>)Parameters["Schedule"]; }
     }
+    public IValueLookupParameter<IntValue> JobsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
+    }
+    public IValueLookupParameter<IntValue> ResourcesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
+    }
 
     [StorableConstructor]
@@ -40,5 +47,7 @@
     public ScheduleCreator()
       : base() {
-      Parameters.Add(new LookupParameter<ISchedule>("Schedule", "The new scheduling solutioncandidate."));
+      Parameters.Add(new LookupParameter<ISchedule>("Schedule", "The new scheduling solution candidate."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
     }
 
Index: /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs
===================================================================
--- /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 13437)
+++ /branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 13437)
@@ -0,0 +1,159 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public abstract class ScheduleEncoding : Encoding<ISchedule>, IScheduleEncoding {
+    #region Encoding Parameters
+    [Storable]
+    private IFixedValueParameter<ItemList<Job>> jobDataParameter;
+    public IFixedValueParameter<ItemList<Job>> JobDataParameter {
+      get { return jobDataParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("JobData parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("JobData parameter value must not be null.");
+        if (jobDataParameter == value) return;
+
+        if (jobDataParameter != null) Parameters.Remove(jobDataParameter);
+        jobDataParameter = value;
+        Parameters.Add(jobDataParameter);
+        OnJobDataParameterChanged();
+      }
+    }
+
+    [Storable]
+    private IFixedValueParameter<IntValue> jobsParameter;
+    public IFixedValueParameter<IntValue> JobsParameter {
+      get { return jobsParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("Jobs parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("Jobs parameter value must not be null.");
+        if (jobsParameter == value) return;
+
+        if (jobsParameter != null) Parameters.Remove(jobsParameter);
+        jobsParameter = value;
+        Parameters.Add(jobsParameter);
+        OnJobsParameterChanged();
+      }
+    }
+    [Storable]
+    private IFixedValueParameter<IntValue> resourcesParameter;
+    public IFixedValueParameter<IntValue> ResourcesParameter {
+      get { return resourcesParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("Resources parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("Resources parameter value must not be null.");
+        if (resourcesParameter == value) return;
+
+        if (resourcesParameter != null) Parameters.Remove(resourcesParameter);
+        resourcesParameter = value;
+        Parameters.Add(resourcesParameter);
+        OnBoundsParameterChanged();
+      }
+    }
+    #endregion
+
+    public ItemList<Job> JobData {
+      get { return JobDataParameter.Value; }
+    }
+    public int Jobs {
+      get { return JobsParameter.Value.Value; }
+      set { JobsParameter.Value.Value = value; }
+    }
+    public int Resources {
+      get { return ResourcesParameter.Value.Value; }
+      set { ResourcesParameter.Value.Value = value; }
+    }
+
+
+    [StorableConstructor]
+    protected ScheduleEncoding(bool deserializing) : base(deserializing) { }
+    protected ScheduleEncoding(ScheduleEncoding original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    protected ScheduleEncoding() : this("Schedule") { }
+    protected ScheduleEncoding(string name) : this(name, Enumerable.Empty<Job>()) { }
+    protected ScheduleEncoding(string name, IEnumerable<Job> jobData)
+      : base(name) {
+      int jobs = jobData.Count();
+      int resources = jobData.SelectMany(j => j.Tasks).Select(t => t.ResourceNr).Distinct().Count();
+
+      jobDataParameter = new FixedValueParameter<ItemList<Job>>(Name + ".JobData", new ItemList<Job>(jobData));
+      jobsParameter = new FixedValueParameter<IntValue>(Name + ".Jobs", new IntValue(jobs));
+      resourcesParameter = new FixedValueParameter<IntValue>(Name + ".Resources", new IntValue(resources));
+
+      Parameters.Add(jobDataParameter);
+      Parameters.Add(jobsParameter);
+      Parameters.Add(resourcesParameter);
+    }
+
+    private void OnJobDataParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+    private void OnJobsParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+    private void OnBoundsParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+
+
+    public override void ConfigureOperators(IEnumerable<IItem> operators) {
+      ConfigureCreators(operators.OfType<IScheduleCreator>());
+      ConfigureCrossovers(operators.OfType<IScheduleCrossover>());
+      ConfigureManipulators(operators.OfType<IScheduleManipulator>());
+    }
+
+    private void ConfigureCreators(IEnumerable<IScheduleCreator> creators) {
+      foreach (var creator in creators) {
+        creator.ScheduleParameter.ActualName = Name;
+        creator.JobsParameter.ActualName = JobsParameter.Name;
+        creator.ResourcesParameter.ActualName = ResourcesParameter.Name;
+      }
+    }
+
+    private void ConfigureCrossovers(IEnumerable<IScheduleCrossover> crossovers) {
+      foreach (var crossover in crossovers) {
+        crossover.ChildParameter.ActualName = Name;
+        crossover.ParentsParameter.ActualName = Name;
+      }
+    }
+
+    private void ConfigureManipulators(IEnumerable<IScheduleManipulator> manipulators) {
+      foreach (var manipulator in manipulators)
+        manipulator.ScheduleParameter.ActualName = Name;
+    }
+  }
+}
